<?php

namespace STM\Match;

use STM\DB\SQL\SelectQuery;
use \Exception;
use STM\StmFactory;

/**
 * Test class for MatchSelection.
 * Generated by PHPUnit on 2011-09-03 at 13:25:46.
 * @group match
 */
class MatchSelectionTest extends \PHPUnit_Framework_TestCase {

    private $allMatches;
    private $without_periods;
    private $upcoming_matches;
    private $bad_values;

    protected function setUp() {
        $builder = new MatchSelectionBuilder();
        $this->allMatches = getMatchSelection(MatchSelection::ALL_MATCHES, true, true);
        $this->allMatches = $builder->build($this->allMatches);
        $this->without_periods = getMatchSelection(MatchSelection::ALL_MATCHES, true, false);
        $this->without_periods = $builder->build($this->without_periods);
        $this->upcoming_matches = getMatchSelection(MatchSelection::UPCOMING_MATCHES, true, true);
        $this->upcoming_matches = $builder->build($this->upcoming_matches);
        $this->bad_values = array('dsadas', null, false, array(), new Exception());
    }

    protected function tearDown() {
        
    }

    public function testGet_match_query() {
        // for all instance it always returns instance of SelectQuery
        $this->assertTrue($this->allMatches->getSelectQuery() instanceof SelectQuery);
        $this->assertTrue($this->without_periods->getSelectQuery() instanceof SelectQuery);
        $this->assertTrue($this->upcoming_matches->getSelectQuery() instanceof SelectQuery);
    }

    public function testSet_competition() {
        $competition = StmFactory::find()->Competition->findById(1);
        if ($competition) {            
            $this->allMatches->setCompetition($competition);
            $this->assertTrue(is_int(strpos($this->allMatches->getSelectQuery()->__toString(), "id_competition = '{$competition->getId()}'")));
            $this->allMatches = getMatchSelection(MatchSelection::ALL_MATCHES, true, true);
        }
    }

    public function testSet_selected_teams() {
        // sets only if non empty array which contains instances of Team or team id
        $team = StmFactory::find()->Team->findById(1);
        if ($team) {
            $this->allMatches->setSelectedTeams(array($team, false));
            $this->assertTrue(is_int(strpos($this->allMatches->getSelectQuery()->__toString(), "id_home IN ('{$team->getId()}')")));
            $this->allMatches = getMatchSelection(MatchSelection::ALL_MATCHES, true, true);
        }        
    }

    public function testSet_head_to_head() {
        // sets only if instance of team
        foreach ($this->bad_values as $value) {
            $this->allMatches->setHeadToHead(array($value, $value));
            $this->assertFalse(strpos($this->allMatches->getSelectQuery()->__toString(), "id_home ='"));
        }

        $team_a = StmFactory::find()->Team->findById(1);
        $team_b = StmFactory::find()->Team->findById(2);
        if ($team_a && $team_b) {
            $this->allMatches->setHeadToHead(array($team_a, $team_b, false));
            $this->assertTrue(is_int(strpos($this->allMatches->getSelectQuery()->__toString(), "matches.id_home IN ('{$team_a->getId()}', '{$team_b->getId()}')")));
            $this->allMatches = getMatchSelection(MatchSelection::ALL_MATCHES, true, true);
        }
    }

    public function testSet_id_match() {
        foreach ($this->bad_values as $value) {
            $this->allMatches->setId($value);
            $this->assertFalse(strpos($this->allMatches->getSelectQuery()->__toString(), "matches.id_match = '"));
        }
        $this->allMatches->setId(11);
        $this->assertTrue(is_int(strpos($this->allMatches->getSelectQuery()->__toString(), "matches.id_match = '11'")));
    }

    public function testSet_dates() {
        // at least one argument must string with valid date
        $this->allMatches->setDates(null, null);
        $this->assertFalse(is_int(strpos($this->allMatches->getWhereCondition()->__toString(), 'matches.datetime')));
        // if only min then if date is bigger than
        $this->allMatches->setDates('now', null);
        $this->assertTrue(is_int(strpos($this->allMatches->getWhereCondition()->__toString(), 'matches.datetime >= ')));
        // if only min then if date is smaller than
        $this->allMatches->setDates(null, 'now');
        $this->assertTrue(is_int(strpos($this->allMatches->getWhereCondition()->__toString(), 'matches.datetime <= ')));
        // if both -> in range
        $this->allMatches->setDates('yesterday', 'now');
        $this->assertTrue(is_int(strpos($this->allMatches->getWhereCondition()->__toString(), 'matches.datetime BETWEEN ')));
    }

    public function testLoad_periods() {
        $this->assertTrue($this->allMatches->loadPeriods());
        $this->assertFalse($this->without_periods->loadPeriods());
        // upcoming matches have always false
        $this->assertFalse($this->upcoming_matches->loadPeriods());
    }

    public function testSetYourTeamsOnly() {
        $this->allMatches->setYourTeamsOnly();
        $condition = $this->allMatches->getWhereCondition()->__toString();
        $this->assertTrue(is_int(strpos($condition, "your_team = 'Y'")));
        $query = $this->allMatches->getSelectQuery()->__toString();
        $this->assertTrue(is_int(strpos($query, 'JOIN ' . DT_COMPETITIONS_TEAMS)));
    }

}

?>
